'''
    ERROR CORRECTING

    Your task is to write a function correct(strings) that tries to recover 
    a string that has been corrupted by transmission errors. The string has
    been transmitted n times, with possible different transmission errors 
    each time. All received strings have equal length. We assume a character
    at index i is correct if it is identical for more than half of the given
    strings. Otherwise we return a '?' for that character.

    Example: If we receive the three strings ABC, ACC and BAB we can
             recover the first character as A since two of the strings
             has A as the first character. Similarly the last character can
             be recovered as C. The middle character is different in all
             three strings, so we return a '?' for that character.
    
    Input:  A single line with the n strings separated by spaces.
            All n strings have equal length, where 1 <= n <= 10 and 
            1 <= length <= 10.

    Output: The recovered string, with '?' for characters that could not
            be recovered.

    Example:

      Input:  ABC ACC BAB

      Output: A?C

    Note: The below code already reads the strings and prints the output
          generated by calling the function correct.
'''


def correct(strings):
    # insert code
    pass
#> validate input
    assert 1 <= len(strings) <= 10
    assert all(isinstance(string, str) for string in strings)
    assert all(1<= len(string) == len(strings[0]) <= 10 for string in strings)
#< validate input
#> solution
    answer = ['?'] * len(strings[0])
    for i, chars in enumerate(zip(*strings)):
        for char in chars:
            if chars.count(char) > len(chars) / 2:
                answer[i] = char
    return ''.join(answer)
#< solution


print(correct(input().split()))
