'''
    QUEENS BOARD

    Your task is to implement a class Queens that represents a chess board
    with a set of queens placed on it. The class should support the following:

        Queens()

            Creates a new empty 8x8 chess board.

        board.set(position)

            Assuming board is an instance of class Queens, places a queen 
            at the position, where position e.g. is the string 'A3'.
            It is required that there is no queen at the position before
            the call to set. A position is a string of length two where
            the first character is a letter in the range 'A' to 'H' and the
            second character is a digit in the range '1' to '8'.

        board.clear(position)

            Remove the queen at the position. It is required that there is
            a queen at the position before the call to clear.

        board.print()

            Prints the chess board, with the queens represented by 'Q', 
            in the following format:

                8 ........
                7 ..Q.....
                6 ........
                5 ........
                4 .....Q..
                3 Q.......
                2 ........
                1 ........
                / ABCDEFGH

        board.valid()

            Returns True if the queens on the board are placed in a valid
            position, i.e., no queen can attack another queen. Otherwise
            returns False.

    Input:  Multiple lines of Python code using the class Queens.
            The last line should start with '#eof' (indicating end of file).

    Output: The output generated by executing the input code.

    Example:

      Input:  board = Queens()
              board.set('A3')
              board.set('F4')
              board.set('C7')
              board.print()
              #eof

      Output: 8 ........
              7 ..Q.....
              6 ........
              5 ........
              4 .....Q..
              3 Q.......
              2 ........
              1 ........
              / ABCDEFGH

    Note: The below code already handles reading and executing the input.             
'''


class Queens:
    # insert code
    pass
#> solution

    def __init__(self):
        self.queens = set()

    def print(self):
        rows = '12345678'
        columns = 'ABCDEFGH'
        for row in reversed(rows):
            print(row, ''.join('Q' if column + row in self.queens else '.' for column in columns))
        print('/ ' + columns)

    def set(self, position):
#< solution
#> validate input
        column, row = position
        assert row in '12345678'
        assert column in 'ABCDEFGH'
        assert position not in self.queens
#< validate input
#> solution
        self.queens.add(position)

    def clear(self, position):
#< solution
#> validate input
        column, row = position
        assert row in '12345678'
        assert column in 'ABCDEFGH'
        assert position in self.queens
#< validate input
#> solution
        self.queens.remove(position)

    def valid(self):
        for p in self.queens:
            for q in self.queens:
                if p != q:
                    p_column, p_row = p
                    q_column, q_row = q
                    if p_row == q_row or p_column == q_column or abs(int(p_row) - int(q_row)) == abs(ord(p_column) - ord(q_column)):
                        return False
        return True
#< solution


import sys
code = ''
for line in sys.stdin:
    code += line
    if line.startswith('#eof'):
        break
#> validate last line is #eof
assert line.startswith('#eof')
#< validate
exec(code)
