r'''
    TREE GENERATOR

    Your task is to implement a generator binary_trees(labels) that generates
    all binary trees with the given leaf labels, i.e., all trees will have
    len(labels) leaves, and these are labeled left-to-right with the elements
    of labels. The trees should be generated as nested tuples, where a leaf
    is represented by a string and a non-leaf node is represented by a tuple
    of two trees. The trees should be generated in the order such that trees
    with a heavier left subtree are generated before trees with a heavier 
    right subtree (recursively defined). 

    Example: 
    
      binary_trees(['A', 'B', 'C', 'D']) should generate the following
      four trees in the given left-to-right order.

             /\           /\           /\           /\          /\   	     
            /  \         /  \         /  \         /  \        /  \  
           /\   D       /\   D       /    \       A   /\      A   /\ 
          /  \         /  \         /\    /\         /  D        B  \
         /\   C       A   /\       A  B  C  D       /\              /\   
        A  B             B  C                      B  C            C  D  

                        ((('A', 'B'), 'C'), 'D')
                        (('A', ('B', 'C')), 'D')
                        (('A', 'B'), ('C', 'D'))
                        ('A', (('B', 'C'), 'D'))
                        ('A', ('B', ('C', 'D')))

    Input:  Multiple lines of Python code using the generator binary_trees.
            The last line should start with '#eof' (indicating end of file).
            It is guaranteed that len(labels) <= 100.

    Output: The output generated by executing the input code.

    Example:

      Input:  for tree in binary_trees(['A', 'B', 'C', 'D']):
                  print(tree)
              #eof

      Output: ((('A', 'B'), 'C'), 'D')
              (('A', ('B', 'C')), 'D')
              (('A', 'B'), ('C', 'D'))
              ('A', (('B', 'C'), 'D'))
              ('A', ('B', ('C', 'D')))

    Note: The below code already handles reading and executing the input.
'''


def binary_trees(labels):
    # insert code
    pass
#> validate input
    assert isinstance(labels, list)
    assert all(isinstance(label, str) for label in labels)
    assert len(labels) == len(set(labels))
    assert len(labels) <= 100
#< validate input
#> solution
    if len(labels) == 1:
        yield labels[0]
    else:
        for i in reversed(range(1, len(labels))):
            for left in binary_trees(labels[:i]):
                for right in binary_trees(labels[i:]):
                    yield (left, right)
#< solution


import sys
code = ''
for line in sys.stdin:
    code += line
    if line.startswith('#eof'):
        break
#> validate last line is #eof
assert line.startswith('#eof')
#< validate
exec(code)
