'''
    POWER

    Assume you have a class that supports the operator *, i.e. the class
    implements the method __mul__.

    Your task is to create a class decorator add_power, that adds support for 
    the power operator ** to the class. If x is an instance of the class,
    x ** 4 should be equivalent to computing ((x * x) * x) * x. 
    We assume that when computing x ** power it is guaranteed that power 
    is an integer, where 1 <= power <= 100.

    An example could be the following class MyFraction representing fractions.

        @add_power
        class MyFraction:
            def __init__(self, numerator, denominator):
                self.numerator = numerator
                self.denominator = denominator

            def __str__(self):
                return f'MyFraction({self.numerator}, {self.denominator})'

            def __mul__(self, other):
                return MyFraction(self.numerator * other.numerator, 
                                  self.denominator * other.denominator)

        print(MyFraction(2, 3) ** 3)

    should print

        MyFraction(8, 27)

    since (2 / 3) ** 3 == 8 / 27.
            
    Your implementation of the add_power decorator can either modify the
    existing class or create a new class.

    Input:  Multiple lines of Python code using the class decorator add_power.
            The last line should start with '#eof' (indicating end of file).
            
    Output: The output generated by executing the input code.

    Example: 

      Input:  @add_power
              class MyFraction:
                  def __init__(self, numerator, denominator):
                      self.numerator = numerator
                      self.denominator = denominator
  
                  def __str__(self):
                      return f'MyFraction({self.numerator}, {self.denominator})'
  
                  def __mul__(self, other):
                      return MyFraction(self.numerator * other.numerator,
                                        self.denominator * other.denominator)

              print(MyFraction(2, 3) ** 3)

              #eof

      Output: MyFraction(8, 27)

    Note: The below code already handles reading and executing the input.
'''


# insert code
pass
#> solution - decorator creating a new class
def add_power(C):
    class C_new(C):
        def __pow__(self, power):
            assert 1 <= power <= 100
            return (self ** (power - 1)) * self if power > 1 else self
    return C_new
#< solution
#> solution - decorator modifying class C
def add_power(C):
    C.__pow__ = lambda self, power: (self ** (power - 1)) * self if power > 1 else self
    return C
#< solution


import sys
code = ''
for line in sys.stdin:
    code += line
    if line.startswith('#eof'):
        break
#> validate last line is #eof
assert line.startswith('#eof')
#< validate
exec(code)
